﻿Imports System.ComponentModel
Imports System.Drawing
Imports System.Windows.Forms
Imports Angelmarken.dtsAngelmarken

Public Class frmAngelmarken

    Public Sub New()
        InitializeComponent()

        Me.Text = Date.Now.ToString

        If NotifyPropertyChanged.IsInDesignMode Then Return
        ControlStyling.StyleControls(Me)
        Dts.DataFile("..\..\DataStuff\AngelmarkenData.xml").Register(Me, handleFormClosing:=True).Fill
    End Sub

    Private Sub frmAngelmarken_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        'verstecken der Reiter vom Main TabControl
        HideTabs(TCMain)
        'verstecken der Reiter von Einstellungen TabControl
        HideTabs(TCSettings)
        'Prüfen ob es eine Row in dtsAngelmarken.eigeneDaten gibt, wenn nicht anlegen
        If BSeigeneDaten.Count = 0 Then
            dtsAngelmarken.eigeneDaten.AddeigeneDatenRow("", "", "")
        End If
    End Sub
    Private Sub HideTabs(TC As TabControl)
        With TC
            .SuspendLayout()
            .SizeMode = TabSizeMode.Fixed
            .ItemSize = New Size(0, 1)
            .Appearance = TabAppearance.Buttons
            .ResumeLayout()
        End With
    End Sub

    Private Sub frmAngelmarken_KeyPress(sender As Object, e As KeyPressEventArgs) Handles MyBase.KeyPress
        'Strg + K zum kopieren
        If e.KeyChar = "" Then
            If TCMain.SelectedTab Is TPPersons Then PersonCopy()
            Return
        End If
        'Escape
        If e.KeyChar = Convert.ToChar(Keys.Escape) Then
            If TCMain.SelectedTab Is TPPersons Then DelPersonSearch()
            Return
        End If
        'abbrechen, wenn eine Textbox ausgewählt
        If Me.TBPersonSearch.Focused Then Return
        'Taste Backspace
        If e.KeyChar = Convert.ToChar(Keys.Back) Then 'Backspace - Löschen des letzten Zeichens
            If TCMain.SelectedTab Is TPPersons Then
                If TBPersonSearch.Text.Length > 0 Then TBPersonSearch.Text = TBPersonSearch.Text.Substring(0, TBPersonSearch.Text.Length - 1)
            End If
            Return
        End If
        'Tasten in TB übergeben
        If TCMain.SelectedTab Is TPPersons Then TBPersonSearch.AppendText(e.KeyChar)
    End Sub
    Private Sub frmAngelmarken_KeyDown(sender As Object, e As KeyEventArgs) Handles Me.KeyDown
        Select Case e.KeyData
            Case = Keys.Delete
                'entfernen zum löschen einer Person
                If TCMain.SelectedTab Is TPPersons Then PersonDelete()
        End Select
    End Sub

    Private Sub BTNSettings_Click(sender As Object, e As EventArgs) Handles BTNSettings.Click, BTNPersons.Click, BTNNewSale.Click
        Dim pressedButton = DirectCast(sender, Button)
        Select Case pressedButton.Name
            Case = "BTNNewSale"
                Me.TCMain.SelectedTab = TPSale
            Case = "BTNPersons"
                Me.TCMain.SelectedTab = TPPersons
            Case = "BTNSettings"
                Me.TCMain.SelectedTab = TPSettings
        End Select
    End Sub

    Private Sub BTNHome_Click(sender As Object, e As EventArgs) Handles BTNHome.Click
        Me.TCMain.SelectedTab = TPHome
    End Sub

#Region "Tab Page Personen"
    'neue Person
    Private Sub BTNPersonNew_Click(sender As Object, e As EventArgs) Handles BTNPersonNew.Click
        BSPerson.EditNew(Of frmEditPerson)
    End Sub
    'Person bearbeiten
    Private Sub BTNPersonEdit_Click(sender As Object, e As EventArgs) Handles BTNPersonEdit.Click
        PersonEdit()
    End Sub
    Private Sub PersonEdit()
        BSPerson.EditCurrent(Of frmEditPerson)
    End Sub
    'Person kopieren
    Private Sub BTNPersonCopy_Click(sender As Object, e As EventArgs) Handles BTNPersonCopy.Click
        PersonCopy()
    End Sub
    Private Sub PersonCopy()
        'Daten der aktuell ausgewählten Person auslesen
        If BSPerson.Current Is Nothing Then Return
        Dim SelectedPerson = DirectCast(DirectCast(BSPerson.Current, DataRowView).Row, PersonRow)
        'Daten der Adresse an bearbeitenForm übergeben
        With dtsAngelmarken.Person
            Dim tpls = TupleList.From(Of DataColumn, Object)(.NameColumn, SelectedPerson.Name)(.StrasseColumn, SelectedPerson.Strasse) _
                     (.HausnummerColumn, SelectedPerson.Hausnummer)(.PLZColumn, SelectedPerson.PLZ)(.OrtColumn, SelectedPerson.Ort)
            BSPerson.EditNew(Of frmEditPerson)(tpls)
        End With
    End Sub
    'Person löschen
    Private Sub BTNPersonDelete_Click(sender As Object, e As EventArgs) Handles BTNPersonDelete.Click
        PersonDelete()
    End Sub
    Private Sub PersonDelete()
        If BSPerson.Current Is Nothing Then Return
        'ausgewählten Person auslesen
        Dim Person = DirectCast(DirectCast(BSPerson.Current, DataRowView).Row, PersonRow)
        If MessageBox.Show(Person.Vorname & " " & Person.Name & " und all seine Einkäufe werden gelöscht. " & Environment.NewLine &
                           "Sind sie sicher?", "Person löschen", MessageBoxButtons.YesNo) = DialogResult.Yes Then
            Person.Delete()
        End If
    End Sub
    'Suchenfeld löschen
    Private Sub BTNPersonDelSearch_Click(sender As Object, e As EventArgs) Handles BTNPersonDelSearch.Click
        DelPersonSearch()
    End Sub
    Private Sub DelPersonSearch()
        TBPersonSearch.Text = ""
    End Sub
    'Filter für Personbindingsource (Suchen Textbox)
    Private Sub TBPersonSearch_TextChanged(sender As Object, e As EventArgs) Handles TBPersonSearch.TextChanged
        BSPerson.FilterX("Name LIKE *?* OR Vorname LIKE *?*", TBPersonSearch.Text, TBPersonSearch.Text)
    End Sub

#End Region

#Region "Tab Page Settings"

#Region "eigene Daten"

    Private Sub BTNShowownData_Click(sender As Object, e As EventArgs) Handles BTNShowownData.Click
        Me.TCSettings.SelectedTab = TPownData
    End Sub

    Private Sub BTNSaveOwnData_Click(sender As Object, e As EventArgs) Handles BTNSaveOwnData.Click
        BSeigeneDaten.EndEdit()
    End Sub
#End Region

#Region "Artikel"

    Private Sub BTNShowownArticle_Click(sender As Object, e As EventArgs) Handles BTNShowArticle.Click
        Me.TCSettings.SelectedTab = TPArticle
    End Sub
    Private Sub BTNAddArticle_Click(sender As Object, e As EventArgs) Handles BTNAddArticle.Click
        'BSArtikel.EditNew(Of frmEditArticle)
        Dim SelectedSupplier = DirectCast(DirectCast(BSLieferant.Current, DataRowView).Row, LieferantRow)
        'einen Lieferanten mit übergeben, da es sonst zum DataError im DGV kommt
        With dtsAngelmarken.Artikel
            Dim tpls = TupleList.From(Of DataColumn, Object)(.LieferantIDColumn, SelectedSupplier.ID)
            'TODO wie stelle ich das an, ohne die ID zu verwenden? Oder ist das hier OK?
            BSArtikel.EditNew(Of frmEditArticle)(tpls)
        End With
    End Sub

    Private Sub BTNEditArticle_Click(sender As Object, e As EventArgs) Handles BTNEditArticle.Click
        BSArtikel.EditCurrent(Of frmEditArticle)
    End Sub

    Private Sub BTNDelArticle_Click(sender As Object, e As EventArgs) Handles BTNDelArticle.Click
        If BSArtikel.Current Is Nothing Then Return
        'ausgewählten Liefanten auslesen
        Dim Article = DirectCast(DirectCast(BSArtikel.Current, DataRowView).Row, ArtikelRow)
        If MessageBox.Show("Der Artikel " & Article.Bezeichnung & " und alle zugehörigen Bestellungen werden gelöscht. " & Environment.NewLine &
                           "Sind sie sicher?", "Artikel löschen", MessageBoxButtons.YesNo) = DialogResult.Yes Then
            Article.Delete()
        End If
    End Sub

#End Region

#Region "Lieferanten"
    Private Sub BTNClickEvents(sender As Object, e As EventArgs) Handles BTNShowSupplier.Click, BTNAddSupplier.Click, BTNEditSupplier.Click, BTNDelSupplier.Click
        Select Case True
            Case sender Is BTNShowSupplier : Me.TCSettings.SelectedTab = TPSupplier
            Case sender Is BTNAddSupplier : BSLieferant.EditNew(Of frmEditSupplier)
            Case sender Is BTNEditSupplier : BSLieferant.EditCurrent(Of frmEditSupplier)
            Case sender Is BTNDelSupplier : DeleteSupplier()
        End Select
    End Sub
    Private Sub DeleteSupplier()
        If BSLieferant.Current Is Nothing Then Return
        'ausgewählten Liefanten auslesen
        Dim Supplier = DirectCast(DirectCast(BSLieferant.Current, DataRowView).Row, LieferantRow)
        If MessageBox.Show("Der Lieferant " & Supplier.Name & " und all seine Artikel werden gelöscht. " & Environment.NewLine &
                           "Sind sie sicher?", "Lieferant löschen", MessageBoxButtons.YesNo) = DialogResult.Yes Then
            Supplier.Delete()
        End If
    End Sub

#End Region

#End Region



End Class